%{
#include "osu8asm.tab.h"
#include <stdio.h>
extern int lineno;
%}

%%
;.*\n				lineno++;

[aA][dD][dD][cC]		return ADD;
[aA][dD][dD]			return ADD;
[aA][nN][dD]			return AND;
[aA][nN][lL]			return AND;
[cC][aA][lL][lL]		return CALL;
[cC][lL][rR]			return CLR;
[cC][jJ][eE]			return CJE;
[cC][jJ][nN][eE]		return CJNE;
[cC][pP][lL]			return CPL;
[dD][eE][cC]			return DEC;
[dD][jJ][nN][zZ]		return DJNZ;
[iI][nN][cC]			return INC;
[jJ][cC][dD]			return JCD;
[jJ][cC][uU]			return JCU;
[jJ][nN][cC]			return JNC;
[jJ][cC]			return JC;
[jJ][nN][nV]			return JNV;
[jJ][nN][zZ]			return JNZ;
[jJ][zZ]			return JZ;
[jJ][nN][pP]			return JNP;
[jJ][pP]			return JP;
[jJ][nV]			return JV;

[jJ][uU][mM][pP]		return JUMP;
[jJ][mM][pP]			return JUMP;
[lL][oO][aA][dD]		return LOAD;
[lL][dD]			return LOAD;
[mM][oO][vV][eE]		return MOVE;
[mM][oO][vV]			return MOVE;
[nN][oO][pP]			return NOP;
[oO][rR][lL]			return OR;
[oO][rR]			return OR;
[pP][oO][pP]			return POP;
[pP][uU][sS][hH]		return PUSH;
[rR][eE][tT][iI]		return RETI;
[rR][eE][tT]			return RET;
[rR][lL][cC]			return RLC;
[rR][lL]			return RL;
[rR][rR][cC]			return RRC;
[rR][rR]			return RR;
[sS][eE][tT][bB]		return SET;
[sS][eE][tT]			return SET;
[sS][tT][oO][rR][eE]		return STORE;
[sS][tT]			return STORE;
[sS][uU][bB][bB]		return SUB;
[sS][uU][bB]			return SUB;

\.[oO][rR][gG]			return ORG;
\.[eE][qQ][uU]			return EQU;
\.[dD][bB]			return DB;
\.[bB][yY][tT][eE]		return DB;

[iI][nN][0]			return IN0;
[iI][nN][1]			return IN1;
[oO][uU][tT][0]			return OUT0;
[oO][uU][tT][1]			return OUT1;
[oO][uU][tT][2]			return OUT2;
[oO][uU][tT][3]			return OUT3;
[sS][pP]			return SP;
[aA][tT]			return AT;
[aA][bB]			return AB;
[bB][tT]			return BT;
[bB][bB]			return BB;
[aA]				return A;
[bB]				return B;
[pP][1][lL][bB]			return P1LB;
[pP][1][lL][tT]			return P1LT;
[pP][1][hH][bB]			return P1HB;
[pP][1][hH][tT]			return P1HT;
[pP][1][lL]			return P1L;
[pP][1][hH]			return P1H;
[pP][1]				return P1;
[pP][2][lL]			return P2L;
[pP][2][hH]			return P2H;
[pP][2]				return P2;
[cC]				return C;
[vV]				return V;
[zZ]				return Z;
[pP]				return P;
[a-zA-Z][a-zA-Z0-9_]*           return WORD;
[01]+[bB]			return BINNUM;
0[xX][0-9a-fA-F]+		return HEXNUM1;
[0-9a-fA-F]+[hH]		return HEXNUM2;
-?[0-9]+			return NUMBER;
\'.\'				return CHAR;
\'\\.\'				return SPCHAR;
\"[^"\n]*["\n]			return STRING;
->				return ',';


[ \t]		;
\n		++lineno;
.		return yytext[0];

%%
