#define state_numbits 6  /* make this user configurable sometime */

/* easiest way to compute 2^n, table lookup... */

static int bitmask[]={1, 2, 4, 8, 16, 32, 64, 128, 256, 512,
		1024, 2048, 4096, 8192, 16384, 32768, 65536,
		131072, 262144, 524288, 1048576, 2097152,
		4194304, 8388608, 16777216, 33554432, 67108864};

/* all the system's input lines */

struct input_list {
        char *name;
        int numbits;
        struct input_list *next; };

/* all of the outputs */

struct output_list {
        char *name;
        int numbits;
        int def;
        int current_value;
        struct output_list *next; };

/* every state that's defined */

struct state_list {
        char *name;
        int code;
        struct job_list *jobs;
        struct action_outs *def_outs;
        struct state_list *next; };

/* user defined action names */

struct action_list {
        char *name;
        struct action_outs *outputs;
        struct action_list *next; };

/* list of actions, used by action_list and job_list */

struct action_outs {
        struct output_list *output;
        int value;
        struct action_outs *next; };

/* all the actions to perform for a state, w/ conditions */

struct job_list {
        struct input_list *cond_input;
        int cond_value;
        struct action_outs *tasks;
        struct job_list *next; };

/* lists of tokens stored by the lexer to remember definitions */

struct token_list {
	int token;
	char *text;
	int value;
	struct token_list *next; };

/* and a list of all the known definitions */

struct definition_list {
	char *name;
	struct token_list *tokens;
	struct definition_list *next; };

/* the final truth table */

struct truth_table {
	char *input;
	char *output;
	struct truth_table *next; };

