
#include <stdio.h>
#include "ucode.h"
#include "ucodeglobals.h"


void undef_err(thename, thefield)
char *thename, *thefield;
{
	fprintf(stderr, "Error: %s \"%s\" is not undefined\n", \
	thefield, thename);
	fprintf(stderr, "       last line processed: %d\n", lineno);
	exit(1);
}


void undef_state_err(thename)
char *thename;
{ undef_err(thename, "state"); }

void undef_input_err(thename)
char *thename;
{ undef_err(thename, "input"); }

void undef_output_err(thename)
char *thename;
{ undef_err(thename, "output"); }

void undef_action_err(thename)
char *thename;
{ undef_err(thename, "action"); }

void cond_input_limitation_error(state_name)
char *state_name;
{
	fprintf(stderr, "Error, two conditional input within one state!\n");
	fprintf(stderr, "offending state \"%s\".\n", state_name);
	fprintf(stderr, "This is a limitation of this program that will\n");
	fprintf(stderr, "hopefully be fixed someday.  Sorry.\n");
	exit(1);
}




yyerror(s)
char *s;
{
	fprintf(stderr, "%s near '%s', line %d\n", s, yytext, lineno);
	exit(1);
}

int yywrap()
{
	return 1;
}

/* mainly for debugging */

void print_ucode()
{
	struct state_list *state;
	struct action_outs *out;
	struct job_list *job;

	state = begin_state_list;
	while (state != NULL) {
		printf("State: \"%s\"  (code=%d)\n", state->name, state->code);
		out = state->def_outs;
		if (out != NULL) printf("  Unconditional Outputs Defined:\n");
		while (out != NULL) {
			printf("      %s = %d\n", out->output->name, out->value);
			out = out->next;
		}
		job = state->jobs;
		if (job != NULL) printf("  Conditional Outputs Defined:\n");
/* prints far too much stuff to be useful...
		while (job != NULL) {
			printf("    If %s == %d then:\n", job->cond_input->name, \
			  job->cond_value);
			out = job->tasks;
			while (out != NULL) {
				printf("      %s = %d\n", out->output->name, \
				  out->value);
				out = out->next;
			}
			job = job->next;
		}
*/
		state = state->next;
	}
}

void print_definitions()
{
	struct definition_list *pdfn;
	struct token_list *ptok;

	pdfn = begin_definition_list;
	if (pdfn != NULL) printf("Definitions:\n");
	while (pdfn != NULL) {
		printf("  \"%s\"\n", pdfn->name);
		ptok = pdfn->tokens;
		while (ptok != NULL) {
			printf("    %s  (%d)\n", ptok->text, ptok->token);
			ptok = ptok->next;
		}
		pdfn = pdfn->next;
	}
}


