/* produce a truth table in memory... */
/* could use a lot of memory! */

#include <stdio.h>
#include "ucodell.h"
#include "ucodedebug.h"
#include "ucode.h"
#include "ucodeglobals.h"


char *pbin(int the_number, int number_of_bits)
{
	register int i;
	static char bin_number[1023];

	if (the_number == -1)
		for (i=0; i<=number_of_bits-1; i++) bin_number[i] = 'X';
	else
		for (i=0; i<=number_of_bits-1; i++) {
			if (bitmask[i] & the_number)
				bin_number[number_of_bits-i-1] = '1';
			else
				bin_number[number_of_bits-i-1] = '0';
		}

	bin_number[number_of_bits] = '\0';
	return (bin_number);

}


/* nasty assumption that all conditional assignments depend on only */
/* one of the inputs.  Maybe I'll figure out a way around this someday */

void create_tt()
{
	register struct input_list *p_input;
	register struct state_list *p_state;
	register struct output_list *p_output;
	register struct action_outs *p_actout;
	struct action_outs *c_actout;
	struct input_list *c_input;
	struct job_list *p_job;
	int j;
	char input_line[4095];
	char output_line[4095];

	p_state = begin_state_list;
	while (p_state != NULL) {
		if (fout != stdout) {
			printf("   State: %d  \"%s\"               \r", \
				p_state->code, p_state->name);
			fflush(stdout);
		}
		if (p_state->jobs == NULL) {   /* if no conditional outputs */

			strcpy(input_line, pbin(p_state->code, state_numbits));
			strcat(input_line, "_");

			p_input = begin_input_list;
			while (p_input != NULL) {  /* all inputs are don't care */
				strcat(input_line, pbin(-1, p_input->numbits));
				p_input = p_input->next;
				if (p_input != NULL) strcat(input_line, "_");
			}

			p_output = begin_output_list;
			output_line[0] = '\0';
			while (p_output != NULL) {
				p_actout = p_state->def_outs;
				while (p_actout != NULL) {
					if (p_actout->output == p_output) break;
					p_actout = p_actout->next;
				}
				if (p_actout == NULL) {  /* if no value specified */
					strcat(output_line, pbin(p_output->def, p_output->numbits));
				} else {   /* ouptut specified in ucode */
					strcat(output_line, pbin(p_actout->value, p_output->numbits));
				}
				p_output = p_output->next;
				if (p_output != NULL) strcat(output_line, "_");
			}
			add_truth_table(input_line, output_line);

		} else {  /* it has conditional terms */

			/* for now, make the bad assumption that */ 
			/* it only depends on only one of the inputs */

			p_input = begin_input_list;
			while (p_input != NULL) {
				if (p_input == p_state->jobs->cond_input) break;
				p_input = p_input->next;
			}
			if (p_input == NULL) {
				fprintf(stderr, "Internal error, conditional input for ");
				fprintf(stderr, "state \"%s\"\n", p_state->name);
				fprintf(stderr, "  not found in input list!!\n");
				exit(1);
			}
			c_input = p_input;  /* remember which one is the condition */
			/* j counts which input condition we're on */
			for (j=0; j<bitmask[c_input->numbits]; j++) {


				strcpy(input_line,  pbin(p_state->code, state_numbits));
				strcat(input_line, "_");

				p_input = begin_input_list;
				while (p_input != NULL) {
					if (p_input != c_input)
						strcat(input_line, pbin(-1, p_input->numbits));
					else
						strcat(input_line, pbin(j, p_input->numbits));
					p_input = p_input->next;
					if (p_input != NULL) strcat(input_line, "_");
				}
				p_output = begin_output_list;
				output_line[0] = '\0';
				while (p_output != NULL) {
					/* first let's check if this output is set */
					/* by some conditional definition */
					p_job = p_state->jobs;
					c_actout = NULL;
					while (p_job != NULL) {
						if (p_job->cond_input != c_input)
							cond_input_limitation_error(p_state->name);
						if (p_job->cond_value == j) {
							p_actout = p_job->tasks;
							while (p_actout != NULL) {
								if (p_actout->output == p_output) {
									c_actout = p_actout;
									break;
								}
								p_actout = p_actout->next;
							}
						}
						if (c_actout != NULL) break;
						p_job = p_job->next;
					}
                                	p_actout = p_state->def_outs;
                                	while (p_actout != NULL) {
                                        	if (p_actout->output == p_output) break;
                                        	p_actout = p_actout->next;
                                	}
					if (c_actout != NULL) {  /* if conditional output value */
						strcat(output_line, pbin(c_actout->value, p_output->numbits));
					} else {  /* not condition, either uncond or default */
                                		if (p_actout == NULL) {  /* if no value specified */
							strcat(output_line, pbin(p_output->def, p_output->numbits));
                                		} else {   /* ouptut specified in ucode */
							strcat(output_line, pbin(p_actout->value, p_output->numbits));
                                		}
					}
					p_output = p_output->next;
					if (p_output != NULL) strcat(output_line, "_");


				} /* end of loop through outputs */

				add_truth_table(input_line, output_line);

			} /* for loop, stepping through possible inputs */

		} /* end of if/then/else conditional or unconditional */

		p_state = p_state->next;
	} /* end of state loop */


	/* now add don't care cases for unused states */
	for (j=0; j<bitmask[state_numbits]; j++) {
		p_state = begin_state_list;
		while (p_state != NULL) {
			if (p_state->code == j) break;
			p_state = p_state->next;
		}
		if (p_state != NULL) continue;

		/* ok, we know j is an unused state */

		strcpy(input_line, pbin(j, state_numbits));
		p_input = begin_input_list;
		while (p_input != NULL) {
			strcat(input_line, "_");
			strcat(input_line, pbin(-1, p_input->numbits));
			p_input = p_input->next;
		}
		p_output = begin_output_list;
		output_line[0] = '\0';
		while (p_output != NULL) {
			strcat(output_line, pbin(-1, p_output->numbits));
			p_output = p_output->next;
			if (p_output != NULL) strcat(output_line, "_");
		}
		add_truth_table(input_line, output_line);
	}

	if (fout != stdout) printf("\n");
}


