#include <stdio.h>
#include "ucodell.h"
#include "ucodedebug.h"
#include "ucode.h"
#include "ucodeglobals.h"


int count_inputs()
{
        register struct input_list *p_input;
        register int lines=0;

        p_input = begin_input_list;
        while (p_input != NULL) {
                lines += p_input->numbits;
                p_input = p_input->next;
        }

	lines += state_numbits;

        return (lines);
}

int count_outputs()
{
        register struct output_list *p_output;
        register int lines=0;

        p_output = begin_output_list;
        while (p_output != NULL) {
                lines += p_output->numbits;
                p_output = p_output->next;
        }
        return (lines);
}


int count_lines()
{
        register struct truth_table *p;
        register int lines=0;


        p = begin_truth_table;
        while (p != NULL) {
		lines++;
		p = p->next;
	}
	return (lines);
}



vhdl_output()
{
        int i;
        struct input_list *p_input;
        struct output_list *p_output;
	struct truth_table *p_tt;
        char name[] = "control";


	fprintf(fout, "library synth;\nuse synth.stdsynth.pla_table;\n\n");
	fprintf(fout, "entity %s is\nport (\n", name);

	fprintf(fout, "\tsignal %s: in vlbit_1d(%d downto 0);\n", \
		"state", state_numbits-1);
		
	p_input = begin_input_list;
	while (p_input != NULL) {
		if (p_input->numbits == 1) {
			fprintf(fout, "\tsignal %s: in vlbit;\n", p_input->name);
		} else {
			fprintf(fout, "\tsignal %s: in vlbit_1d(%d downto 0);\n", \
				p_input->name, p_input->numbits-1);
		}
		p_input = p_input->next;
	}
	p_output = begin_output_list;
	while (p_output != NULL) {
		if (p_output->numbits == 1) {
			fprintf(fout, "\tsignal %s: out vlbit", p_output->name);
		} else {
			fprintf(fout, "\tsignal %s: out vlbit_1d(%d downto 0)", \
				p_output->name, p_output->numbits-1);
		}
		p_output = p_output->next;
		if (p_output == NULL) fprintf(fout, "\n");
		else fprintf(fout, ";\n");
	}

	fprintf(fout, ");\nend %s;\n\narchitecture behavior of %s is\n", name, name);
	fprintf(fout, "signal tmp_input : vlbit_1d(%d downto 0);\n", count_inputs()-1);
	fprintf(fout, "signal tmp_output : vlbit_1d(%d downto 0);\n", count_outputs()-1);

	fprintf(fout, "constant tbl: vlbit_2d(0 to %d, %d downto 0) := (\n\n", \
		count_lines()-1, count_inputs()+count_outputs()-1);

	p_tt = begin_truth_table;
	while (p_tt != NULL) {
		fprintf(fout, "  B\"%s_%s\"", p_tt->input, p_tt->output);
		if (p_tt->next != NULL)
			fprintf(fout, ",\n");
		else
			fprintf(fout, "\n");
		p_tt = p_tt->next;
	}


	fprintf(fout, ");\nbegin\n");
	fprintf(fout, "  tmp_input <= ");
	fprintf(fout, "state");
	if (begin_input_list == NULL) {
		fprintf(fout, ";\n");
	} else {
		fprintf(fout, " & ");
	}
	p_input = begin_input_list;
	while (p_input != NULL) {
		fprintf(fout, "%s", p_input->name);
		p_input = p_input->next;
		if (p_input == NULL) {
			fprintf(fout, ";\n");
		} else {
			fprintf(fout, " & ");
		}
	}

	fprintf(fout, "  pla_table(tmp_input, tmp_output, tbl);\n");

	p_output = begin_output_list;
	i = count_outputs()-1;
	while (p_output != NULL) {
		if (p_output->numbits == 1) {
			fprintf(fout, "  %s <= tmp_output(%d);\n", \
				p_output->name, i);
		} else {
			fprintf(fout, "  %s <= tmp_output(%d downto %d);\n", \
				p_output->name, i, i-p_output->numbits+1);
		}
		i -= p_output->numbits;
		p_output = p_output->next;

	}
	fprintf(fout, "end behavior;\n\n");
	fflush(fout);
}

